// enable double-clicking from Mac Finder or Windows Explorer
#target photoshop

//var exportPath = "C:/Users/abhijitkhairnar/Desktop/Export Layers To Files_trim_jpeg/Abhi.txt";
// bring application forward for double-click events
app.bringToFront();
var doc = app.activeDocument;
var fileLineFeed = ($.os.search(/windows/i) != -1 ? "windows" : "macintosh");
var openFile  = true; // Open file when done (true/false)
var separator = "====================================================================================================";
var semiColon = '';
var progressWindow = createProgressWindow("Please wait...");
var progressStep = Math.round(100 / doc.layers.length);

var data = [];
var dataLayer = [];
var count;

function init() {
  // do we have open document?
  if (app.documents.length === 0) {
    alert("Please open a file", "TextExport Error", true);
    return;
  }
  
   app.preferences.rulerUnits = Units.PIXELS;
   app.preferences.typeUnits = TypeUnits.PIXELS;
	
	
  // open the progress
  progressWindow.show();
  ExportText(doc);
  // close the progress
  progressWindow.close();
  saveResults();
}

 function padder()
{
	var result = "Copy";//(new Array(padLength + 1 - input.toString().length)).join('0') + input;
	return result;
}


 function include(arr, obj) {
    for(var i=0; i<arr.length; i++) {
        if (arr[i] == obj) 
		{
			return true;
		}
    }
	return false;
}

function ExportText(el) {
  // Get the layers
  var layers = el.layers;
  // get layer lenght
  var count = layers.length;
  for (var i = 0; i < count; i++) {
    // curentLayer
    var currentLayer = layers[i];

    if (currentLayer.typename == "LayerSet") {
      ExportText(currentLayer);
    } else {
    // is Text layer visible
      if (currentLayer.visible && currentLayer.kind == LayerKind.TEXT && currentLayer.textItem.contents) {
        doc.activeLayer = currentLayer;

		// Layer Name
        try {
          var layerName = doc.activeLayer.name;
		  //layerName = layerName.replace(/^\s+|\s+$/gm, '');	// trim spaces
		  layerName = layerName.replace(/[\\\*\/\?:"\|<>&]/g, ''); // remove characters not allowed in a file name
		  layerName = layerName.replace(/[ ]/g, '_');			// replace spaces with underscores, since some programs still may have troubles with them
		// alert(validName);
		while(include(dataLayer, layerName))
		{
			layerName = layerName + "-" + padder();
		}

		dataLayer.push(layerName);
		  var layerIndex = i;	
        } catch(e) {
          ;

        }

        // font-size
        try {

          var fontSize = parseInt(currentLayer.textItem.size);

        } catch(e) {
          ;
        }

        // color
        try {
          var color = currentLayer.textItem.color.rgb.hexValue;
        } catch(e) {
			var color = '#ffffff';
        }

        // font-family
        try {
		var fontFamily = currentLayer.textItem.font;
        } catch(e) {
          ;
        }

		 // word-spacing
        try {
		var wordSpacing = currentLayer.textItem.desiredWordScaling;
        } catch(e) {
          ;
        }
		
        // font-style
        try {
          var fontStyle = currentLayer.textItem.fauxItalic;
        } catch(e) {
        }
		
        // font-weight
        try {
          var fontWeight = currentLayer.textItem.fauxBold;
        } catch(e) {
          var fontWeight = '400';
        }

        // check for fontFamily.style
        try {
          var fontFamilyStyle = app.fonts.getByName(fontFamily).style;
        } catch(e) {
			var fontFamilyStyle = '';
        }

        // text-transform
        try {
          var textTransform = currentLayer.textItem.capitalization;
          if (textTransform && textTransform != 'TextCase.NORMAL') {
            var textTransform = 'none';
          }

        } catch(e) {
          var textTransform = 'none';
        }

        // letter-spacing
        try {
          var letterSpacing = currentLayer.textItem.tracking;
        } catch(e) {
        }

        if (letterSpacing != 0) {
          var letterSpacing = ((letterSpacing * fontSize) / 1000);
        }else
		{
		  var letterSpacing = 0;
		}

        // line-height
        try {
          var lineHeight = parseInt(currentLayer.textItem.leading);
        }
        catch (e) {

        };
        // check for fontExist
        try {
          var fontExist = app.fonts.getByName(fontFamily).name;
        } catch(e) {
          var fontExist = false;
        }

        if (fontExist) {
          var fontFamily = fontExist;
        }
        var opacity = currentLayer.opacity;
        var fillOpacity = currentLayer.fillOpacity;
        var effects = activeLayerHasEffects();

        var obj = {
		       layerIndex : layerIndex,
		       layerName : layerName,
               content : currentLayer.textItem.contents,
               fontSize : fontSize, // from px/pt to rem,
               color : '#' + color.toLowerCase(),
               fontFamily : fontFamily,
               fontExist : fontExist,
               fontStyle : fontStyle,
               fontWeight : fontWeight,
               fontFamilyStyle : fontFamilyStyle,
               textTransform : textTransform,
               letterSpacing : letterSpacing, // calculate to rem
               lineHeight : lineHeight / fontSize, // from px/pt to rem
               opacity : opacity,
               fillOpacity : fillOpacity,
               effects : effects,
			   wordSpacing : wordSpacing
               };
        data.push(obj);
      }
    }
    // Update progress bar value
    progressWindow.bar.value = (100 / (progressStep / i));
  }
}

// get Descriptor
function getDescriptor(psClass, psKey) { // integer:Class, integer:key
   var ref = new ActionReference();
   if(psKey != undefined) ref.putProperty(charIDToTypeID("Prpr"), psKey);
   ref.putEnumerated(psClass , charIDToTypeID("Ordn"), charIDToTypeID("Trgt"));
   return executeActionGet(ref);
};


// check layer for effects
function activeLayerHasEffects() {
   var hasEffect = getDescriptor(charIDToTypeID('Lyr ')).hasKey(stringIDToTypeID('layerEffects'));
   return hasEffect;
};

// progress bar
function createProgressWindow(title, message, min, max) {
  var win;
  win = new Window('palette', title);
  win.bar = win.add('progressbar', undefined, min, max); 
  win.bar.preferredSize = [180, 18];
  return win;
};

// Save the Results
function saveResults() {
  // save dialog
  //var file = File.saveDialog("Please select a file to save the results");
  // if file is not selected
  //if(file == null)
 // {
 //   return;
 // }
  // set filePath
  var filePath = exportPath;
  // create outputFile
  var outputFile = new File(filePath);
  // set linefeed
  outputFile.linefeed = fileLineFeed;
  // open for write
  outputFile.open("w", "TEXT", "????");
  // Append title of document to file
  outputFile.writeln(separator);
  outputFile.writeln('All visible Text Layers from "' + doc.name + '"');
  outputFile.writeln(separator);

  // put data to file
  for (var i = 0; i < data.length; i++) {
    var object = data[i];
	outputFile.writeln('layerName' + ': ' + object.layerName + '\n');
	outputFile.writeln('layerIndex' + ': ' + object.layerIndex + '\n');

    outputFile.writeln('text' + ': ' + object.content + '\n');
    outputFile.writeln('fontSize' + ': ' + object.fontSize + '' + semiColon);
    outputFile.writeln('color' + ': ' + object.color + semiColon);
    outputFile.writeln('fontFamily' + ': ' + object.fontFamily + semiColon);
    if (object.fontStyle) {
      outputFile.writeln('fontStyle' + ': ' + object.fontStyle + semiColon);
    }
	else
	{
		outputFile.writeln('fontStyle' + ': normal'  + semiColon);
	}

    if (object.fontWeight) {
      outputFile.writeln('fontWeight: 700' + semiColon);
    }else
	{
	  outputFile.writeln('fontWeight: 400' + semiColon);
	}

    outputFile.writeln('textTransform:' + ': ' + object.textTransform + semiColon);
      outputFile.writeln('letterSpacing' + ': ' + object.letterSpacing + '' + semiColon);
	  outputFile.writeln('wordSpacing' + ': ' + '0' + 'px' + semiColon);
	  
	
    if(object.lineHeight)

	{
		outputFile.writeln('lineHeight' + ': ' + object.lineHeight + 'em' + semiColon);
	}
	else
	{
		outputFile.writeln('lineHeight' + ': ' + '1' + 'em' + semiColon);
	}
	outputFile.writeln('textAlign: start' + semiColon);
    outputFile.writeln('textDecoration: none' + semiColon);
	outputFile.writeln('rotate: 0' + semiColon);

    outputFile.writeln('');
    if (object.fontExist) {
      //outputFile.writeln('* Important' + ': ' + 'Font Family Style is "' + object.fontFamilyStyle +'"');
    } else {
     // outputFile.writeln('* Important' + ': ' + 'The following font is missing: ' + object.fontFamily);
    }
    if (object.effects) {
     // outputFile.writeln('* Important: This layer have some Blending Options');
    }

   // if (object.opacity != '100' || object.fillOpacity != '100') {
	  outputFile.writeln('opacity' + ': ' + Math.round(object.opacity) + semiColon);
	  outputFile.writeln('Fill' + ': ' + object.fillOpacity + semiColon);

   // }
    outputFile.writeln('');
    outputFile.writeln(separator);

  }


  // close the file
  outputFile.close();

  // Give notice that we're done or open the file
  //if (openFile === true) {

  //  outputFile.execute();
  //} else {
  //  alert("File was saved to:\n" + Folder.decode(filePath), "TextExport");
 // }

}

init();